'===============================================================================================
'Character Attribute
' Based on 'aaa' from the forums
'
' By ZeekLumpkins
' V1.2
' Here's how to use these chat commands.

' A list of potential attributes is defined for a session.  We store the list in a session
' variable 'character_attributes', space separated.  In the session, we store the default
' values in a variable called "attr_"&ATTR where ATTR is the attribute to be used.  So if we
' want attributes "str" and "dex", session would have a variable:
' character_attributes = "str dex"
' THere would be 2 session variables "attr_str" and "attr_dex".
' Players would also have 2 character variables, "attr_str" and "attr_dex" with proper values.
'
' Commands:
' see 'chelp'
' 
' TODO
' Smart select of status, GM settable 'read only' for certain fields.
'
'===============================================================================================

#commandset Attribute Tools
'
'caa : Adds attribute to session list of attributes, with default.
#register /caa CharacterAddAttribute (gm) /caa ATTR VALUE :Adds attribute ATTR With default value VALUE
'
'cda : delete attribute to session list of attributes
#register /cda CharacterDelAttribute (gm) /cda ATTR : Deletes attribute ATTR
'
' Lists attributes and their defaults
#register /cla CharacterListAttributes /cla : Shows allowed attributes and default values
'
'
'csa : Adds all missing attributes from the session to all players
#register /csa CharacterSyncAttributes (gm) /csa : Adds all missing attributes For players and assigns defaults 
'
'cca : Changes a player's characteristic value
#register /cca CharacterChangeAttribute /caa PLAYER ATTR VALUE : Change a Character's attribute ATTR to value VALUE.  VALUE can be - or + if the current value is a number. 
'
'chelp : Shows help
#register /chelp CharacterHelp Show Help

' Sheet reports
#register /csheet ShowSheet /csheet CHARACTER : Shows attributes For a player's character.  If (Character) Shows the attributes for a character
#register /cssheet  SummarySheet Shows an attribute summary sheet For all your characters




Sub CharacterHelp
	cs = GetChatSession()
	ci = cs.GetLastItem()
ci.text = "Commands:<br>"

ci.text = ci.text & "<u>/caa ATTR DEFAULT</u><br><b>GM Only</b> Adds a new attribute ATTR to the session with default value DEFAULT<br>"
ci.text = ci.text & "<u>/cda ATTR</u><br><b>GM Only</b> Deletes an attribute ATTR<br>"
ci.text = ci.text & "<u>/cla</u><br>Lists session attributes and their default</td><br>"
ci.text = ci.text & "<u>/csa</u><br><b>GM Only</b> Adds (sync) all current attributes to any characters missing attributes."
ci.text = ci.text &  " It will not overwrite attributes<br>"
ci.text = ci.text & "<u>/cca (CHAR,) ATTR VALUE</u></br>Sets a Attribute value.  If the character name is given "
ci.text = ci.text & "(name must be followed by a comma) it will set it for that character,"
ci.text = ci.text & "otherwise sets it for your first character.  It will not let you set"
ci.text = ci.text & "an ATTR other than ones defined by the GM.  If VALUE is + and the current value is a "
ci.text = ci.text & "number, it will add 1.  If VALUE is a - and the current value is a number, it will subtract 1.<br>"
ci.text = ci.text & "<u>/csheet CHAR</u><br>Shows attribute sheet for character CHAR.  If CHAR is not provided, it "
ci.text = ci.text & "will show the sheet for yor first character<br>"
ci.text = ci.text & "<u>/cssheet</u><br>Shows a sumary sheet of attributes for all your characters<br>"
ci.text = ci.text & "<u>#attr</u><br><b>GM Only</b>Brings up a form to manage attributes<br>"
ci.text = ci.text & "<u>#edit <i>charactername</i></u><br>Brings up a form to edit a character.  You can only edit your own "
ci.text = ci.text & "character.  If <i>charactername</i> is provided, will edit that character instead of the one "
ci.text = ci.text & "currenly selected<br>"
ci.text = ci.text & "<u>/chelp</u><br>shows help<br>"

End Sub



' Gets Character object.  Uses first if not states and allows GMs to get all chars.
Function GetCharacter(name)
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
      
	oPlayer = GetCurrentPlayer()
        
        If oPlayer.GetCharacterCount()>0 and name = "" Then
               GetCharacter=oPlayer.GetCharacterByIndex(0)
        ElseIf NotNull( oPlayer) Then
	    oChar = oPlayer.GetCharacter( name)
            If NotNULL(oChar) Then
              GetCharacter=oChar
            ElseIf oPlayer.IsGM Then
              GetCharacter=os.FindSyncChar(name)
            End If         
        End If

End Function


' List the Session defined attributes and default values
Sub CharacterListAttributes
Dim attrs
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	os.Sync
	ci.PlayerTo=ci.PlayerFrom
	attrs=GetAttrNames()
	ci.PlayerFrom="Current Defined Attributes and default values"
	ci.Action=""
	ci.Text="<ul>"
	For i = 0 to UBound(attrs)
		ci.Text = ci.Text & "<li>" & attrs(i) & ":" & os.GetField("attr_"&attrs(i))  
	Next
      ci.Text = ci.Text & "</ul>"
End Sub

' Add an attribute to the session list
Sub CharacterAddAttribute
Dim attrs, nAttr
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	os.Sync
	attrs=GetAttrNames()
       	ci.PlayerTo=ci.PlayerFrom
	nAttr = Split(Trim(ci.Text), " ",3)
	If GetCurrentPlayer().IsGM=False Then
	  ci.Text = "A pox on you!  You are not the GM."
	  Exit Sub
 	End If
	Select Case  UBound(nAttr)
	Case 0
		newName=Trim(nAttr(0))
		newDefault="na"
		newDescription=""
	Case 1
		newName=Trim(nAttr(0))
		newDefault=Trim(nAttr(1))
		newDescription=""
	Case 2 
		newName=Trim(nAttr(0))
		newDefault=Trim(nAttr(1))
		newDescription=Trim(nAttr(2))
	Case Else
		ci.Text = "Wrong number of arguments"
		Exit Sub
	End Select

	For i = 0 to UBound(attrs)	
		If newName = attrs(i) Then
			ci.Text = "Attribute already added."
			Exit Sub
			' yeah we should allow overwrite
		End If
	Next
	ReDim Preserve attrs(UBound(attrs)+1)
	attrs(UBound(attrs))=newName
      os.SetField "attr_"&newName, newDefault
	os.setField "attr_"&newName&"_desc",newDescription
      SetAttrNames(attrs)
	ci.Text = "Added new attribute '" & newName & "' with default of '" & newDefault & "'"
        

End Sub


' del an attribute to the session list
Sub CharacterDelAttribute
Dim attrs, nAttr
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	os.Sync
	attrs=GetAttrNames()
      ci.PlayerTo=ci.PlayerFrom
	attr=Trim(ci.Text)
	If GetCurrentPlayer().IsGM=False Then
	  ci.Text = "A pox on you!  You are not the GM."
	  Exit Sub
 	End If
	ReDim nAttrs(UBound(attrs)+1)
	ni=0
	For i = 0 to UBound(attrs)	
		If attr <> attrs(i) Then
			nAttrs(ni)=attrs(i)
			ni = ni + 1
		End If
	Next
	If i = ni Then
		ci.text = "Attribute to delete not found."
		Exit Sub
	End If
	ci.text = "Removing attribute " & attr & ".  Note: players will still retain"
	ci.text = ci.text & " the attribute but cannot access it."
	
        SetAttrNames(nAttrs)

End Sub

' Sync the session atribute list with players.  Will add missing values
Sub CharacterSyncAttributes
Dim attrs
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	ci.PlayerTo=ci.PlayerFrom
	os.Sync
	If GetCurrentPlayer().IsGM=False Then
	  ci.Text = "A pox on you!  You are not the GM."
	  Exit Sub
 	End If
	attrs=GetAttrNames()
        name=""
        If Trim(ci.Text) <> "" Then
          name=Trim(ci.Text)
        End If
	n = os.GetSyncCharCount()
        ci.PlayerFrom="Syncing"
	ci.Action=""
	For i = 1 to n
		c = os.GetSyncChar(i)
            If name<>"" and name<>c.name Then
                Continue
            End If
            ci.Text= ci.Text & "Character :" & c.name & " "

		For att = 0 to UBound(attrs)
			avalue=CGetValue(c,attrs(att))
			If  avalue = "" Then
				avalue=os.GetField("attr_"&attrs(att))
				CSetValue c,attrs(attr),avalue
                        ci.Text = ci.Text & "Adding " & attrs(att) & " "	
			End If
		Next
            ci.Text = ci.Text & "<br>"
	Next
End Sub

' New enveloping functions.  Allows us to override where the value comes from

Function CGetValue(character,attribute)
	If LCase(attribute)="hits" Then
		CGetValue=CStr(character.Hits)
	Else
		CGetValue=character.GetField("attr_"&attribute)
	End If
End Function

Sub CSetValue(character, attribute, value)
	If LCase(attribute)="hits" Then
		If IsNumeric(value)=True Then
			character.hits=CInt(value)
		End If
	Else
	character.SetField "attr_"&attribute,value
	End If
End Sub




' Change an attribute value
' Only send back to player
Sub CharacterChangeAttribute
Dim attrs
	cs = GetChatSession()
	ci = cs.GetLastItem()
	ci.PlayerTo=ci.PlayerFrom
	os = GetCurrentSession()
	os.Sync
	attrs=GetAttrNames()
	nandc=Split(Trim(ci.Text),",",2)
        If UBound(nandc)=1 Then
          pname=Trim(nandc(0))
          vpair=Trim(nandc(1))
        Else
	  pname=""
	  vpair=Trim(nandc(0))
	End If
 	vapair=Split(Trim(vpair)," ",2)
        If UBound(vapair)<>1 Then
		ci.Text = "Missing ATTR VALUE (" & vpair & "), #=" & UBound(vapair) & ":" &vapair(0)
		Exit Sub
	End If
	c = GetCharacter(pname)
	If NotNull(c) Then
		found=False
 		For i = 0 to UBound(attrs)
			If vapair(0)=attrs(i) Then
				found=True
			End If
		Next
		If found = False Then
			ci.Text="Invalid ATTR"
			Exit Sub
		End If
	End If
	cvalue=CGetValue(c,vapair(0))
	If vapair(1)="+" and IsNumeric(cvalue) Then
		cvalue=CStr(CInt(cvalue)+1)
	ElseIf vapair(1)="-" and IsNumeric(cvalue) Then
		cvalue=CStr(CInt(cvalue)-1)
	Else 
		cvalue=vapair(1)
	End If
	CSetValue c,vapair(0),cvalue
        ci.Text= "Character :" & c.name & " Setting " & vapair(0) & " to " & cvalue
End Sub

' We keep a list of tracked attributes on the session.
' We set a session variable 'character_attributes' to have a space delimited list of attr names.
' Default is in "attr_" & name for both the session (which holds the default value) and 
' Individual players
Function GetAttrNames
Dim arrwords
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()

        cAttr = os.GetField("character_attributes")
	arrwords = Split(cAttr, " ")
	GetAttrNames=arrwords
End Function

' We keep a list of tracked attributes on the session.
Sub SetAttrNames(arrwords)

	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	arrwords=CompressedArray(arrwords)
        os.SetField "Character_attributes",Join(arrwords)

End Sub

Sub ShowSheet
	cs = GetChatSession()
	ci = cs.GetLastItem()
	ci.PlayerTo=ci.PlayerFrom
	os = GetCurrentSession()
	character=GetCharacter(Trim(ci.Text))
	Sheet(character)
End Sub

' Example simple sheet. takes character object.  caller must set from/to
Sub Sheet(character)

	cs = GetChatSession()
	ci = cs.GetLastItem()
	ci.PlayerTo=ci.PlayerFrom
	os = GetCurrentSession()
	os.Sync
	attrs=GetAttrNames()

	'contents=Split(ci.Text,",",2)	
        pcontents="<html><head><title></title><body background=parchment.gif>"
	pcontents=pcontents+"<b>Character:</b><u>"&character.name&"</u><br>"
	pcontents=pcontents+"<table border=1 cellspacing=0>"
	
 	For i = 0 to UBound(attrs)
		value=CGetValue(character,attrs(i))
		pcontents=pcontents&"<tr><th>"&attrs(i)&"</th><td>"&value&"</td></tr>"
	Next

	pcontents=pcontents&"</table></body></html>"
	
	ci.Text=pcontents
        ' Replace with the below if you have Document loaded
	'ci.Text=PopupText(character.Name,pcontents)

End Sub

'
' Summary sheet : shows all characters owned
Sub SummarySheet
	cs = GetChatSession()
	ci = cs.GetLastItem()
	ci.PlayerTo=ci.PlayerFrom   ' Only show to sender
	os = GetCurrentSession()
	os.Sync
	attrs=GetAttrNames()

	'contents=Split(ci.Text,",",2)	
        pcontents="<html><head><title></title><body background=parchment.gif>"
	pcontents=pcontents+"<table border=1 cellspacing=0>"

	oPlayer = GetCurrentPlayer()


	pcontents=pcontents&"<tr><th>Name</th>"
 	For i = 0 to UBound(attrs)
		pcontents=pcontents&"<th>"&attrs(i)&"</th>"
	Next
	pcontents=pcontents&"</tr>"

	If oPlayer.IsGM = True Then
		ccount = os.GetSyncCharCount()
	Else
		ccount=oPlayer.GetCharacterCount()-1
	End If
	For i = 0 to ccount
		If oPlayer.IsGM=True Then
			os.Sync
			character = os.GetSyncChar(i)
		Else
			character=oPlayer.GetCharacterByIndex(i)
		End If
		If NotNULL(character) Then

			pcontents=pcontents+"<tr><th>"&character.name&"</th>"
		
 			For j = 0 to UBound(attrs)
				value=CGetValue(character,attrs(j))

				pcontents=pcontents&"<td>"&value&"</td>"


			Next
		End If
		pcontent=pcontents&"</tr>"
	Next
	pcontents=pcontents&"</table></body></html>"
	
	ci.Text=pcontents
        ' Replace with the below if you have Document loaded
	' ci.Text=PopupText("Attributes",pcontents)
End Sub

' Removes whitespace and empty items
Function CompressedArray(oldArray)
Dim newArray

	ReDim newArray(UBound(oldArray)+1)
	ni=0
	For i = 0 to UBound(oldArray)
		nvalue=Trim(oldArray(i))
		If nValue<>"" Then
			newArray(ni)=nValue
			ni = ni + 1
		End If
	Next
	ReDim Preserve newArray(ni-1)
	CompressedArray=newArray
End Function

Function StatusArray 
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()
	CRLF = Chr(13) & Chr(10)
	CVal=cs.SessionValues
      StatusArray=Split(CVal,CRLF)
End Function


'
' UI Addons : Handle a character addition request.
' Core attrs: character, info, miniature, attr_XXXX
#event OnPreprocess addCharacter

Sub addCharacter
	cs = GetChatSession()
	ci = cs.GetLastItem()
	os = GetCurrentSession()

	Dim nAction
	nAction = GetCurrentAction()
	player=GetCurrentPlayer()
	
	Select Case nAction
		case 200
			' we need to send the attribute list
			AddLog("Attribute List Request")
			' Next step may be to send info on the default values.
			ReturnText(os.GetField("character_attributes"))
		Case 201
			AddLog("Add Character Request")
			add_name = GetVar("character")
			If Len( add_name) = 0 Then
				AddLog("Empty character name ("&add_name&")")
				exit sub
			end if
			add_info = GetVar("info")
			add_miniature=GetVar("miniature")
			' Add the base character.
			character=player.AddCharacter(add_name, add_miniature)
			if (NotNull(character)) then
				character.info=add_info
				attrs=GetAttrNames()
 				For j = 0 to UBound(attrs)
					aval=GetVar("attr_"&attrs(j))
					if Len(aval) > 0 then
						CSetValue character,attrs(j),aval
					end if
				Next
			else
				AddLog("AddCharacter failed.")
			end if			
		Case 202
			if not player.IsGM then
				exit sub
			end if
			AddLog("Update Attribute List Request")

			
			attrs=GetAttrNames()
			ncount=UBound(attrs)+2
			ReDim nattrs(ncount)
			totalAttrs=0
			
			'  Need to do these in order...
			For j = 0 to UBound(attrs)
				aval=GetVar("opt_attr_"&attrs(j))
				if aval <> "Delete" then
					nattrs(totalAttrs)=attrs(j)
					totalAttrs=totalAttrs+1
				end if
			next
			UAttrs=totalAttrs - 1
			For j = 0 to UAttrs
				aval=GetVar("opt_attr_"&nattrs(j))
				if aval = "Move Up" then
					if (j>0) then
						prev=nattrs(j-1)
						nattrs(j-1)=nattrs(j)
						nattrs(j)=prev
							
					end if
				end if			
			next
			For j = UAttrs to 0
				aval=GetVar("opt_attr_"&nattrs(j))
				if aval = "Move Down" then
					if (j<>UAttrs) then
						prev=nattrs(j+1)
						nattrs(j+1)=nattrs(j)
						nattrs(j)=prev
					end if
				end if

			next
			aval=GetVar("new")
			if aval <> "" then
				nattrs(totalAttrs)=aval
				UAttrs=UAttrs+1
			end if
			ReDim Preserve nattrs(UAttrs)
			sattrs=Join(nattrs)
			AddLog("New attr list:"&sattrs)	
			SetAttrNames(nattrs)	
		case 203
			' we need to send the attributes of a character.
			cname=GetVar("character")
			character=GetCharacter(cname)
			if NotNull(character) then
				AddLog("Getting attributes for " & character.Name)
				creturn="character=" & Escape(character.Name)
				attrs=GetAttrNames()

				for j = 0 to UBound(attrs)
					cval=CGetValue(character,attrs(j))
					creturn=creturn & "&" & attrs(j) & "=" & Escape(cval)
				Next
				creturn=creturn & "&info=" & Escape(character.info)
				ReturnText(creturn)
			else
				ReturnText("")
			end if
		case 204
			AddLog("Edit Character Request")
			edit_name = GetVar("character")
			character=GetCharacter(edit_name)
			edit_info = GetVar("info")
			if (NotNull(character)) then
				character.info=edit_info
				attrs=GetAttrNames()
 				For j = 0 to UBound(attrs)
					aval=GetVar("attr_"&attrs(j))
					if Len(aval) > 0 then
						CSetValue character,attrs(j),aval
					end if
				Next
			else
				AddLog("EditCharacter failed.")
			end if
	End Select
End Sub
